classdef DefaultCurve < handle
    %DEFAULTCURVESELECTION Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        data
          
    end
    
    properties(Constant)
        ANY = 'ANY____';
        NEW = 'NEW____';
        
        NOTHING = 'NOTHING';
        
        FP_init = 'init_FP_FP';
        NS_init = 'init_NSm_NSm';
        PD_init = 'init_PDm_PDm';
        LP_init = 'init_LPm_LPm';
        
    end
    
    methods
        
        function obj = DefaultCurve()
                obj.addDefault( 'FP' , obj.ANY , obj.FP_init);
                obj.addDefault( 'BP' , obj.ANY , 'init_BP_FP');
                obj.addDefault( 'NS' , obj.ANY , obj.NS_init);
                obj.addDefault( 'PD' , obj.ANY , obj.PD_init);
                obj.addDefault( 'LP' , obj.ANY , obj.LP_init);
                
                obj.addDefault( 'R4' , 'NS' ,    'init_R4_LP4m2');
                obj.addDefault( 'R4' , obj.ANY , 'init_R4_LP4m1');
            
            
            
            
        end
        
        
        
        function addDefault(obj,  detectedpointtype,  parentcurvetype , defaultcurvetype)
           obj.data.(detectedpointtype).(parentcurvetype) = defaultcurvetype; 
        end
        
        
        function initlabel = retrieveDefaultCurve(obj , pointtag , parentcurvetag)
            if (~isfield(obj.data, pointtag))
               initlabel = obj.NOTHING;
               return;
            end
            
            if (isempty(parentcurvetag))
               parentcurvetag = obj.NEW; 
            end
            
            if (isfield(obj.data.(pointtag) , parentcurvetag))
               initlabel =  obj.data.(pointtag).(parentcurvetag);
               return;
            elseif (isfield(obj.data.(pointtag) , obj.ANY ))
                initlabel = obj.data.(pointtag).(obj.ANY);
                return;
            else
                initlabel = obj.NOTHING;
                
            end
            
            
        end
        
        
        
        
        
    end
    
end

